Merge pull request #8 from Izakey/FINCN-155

Prepare default setup for PostgreSQL migration
diff --git a/.travis.yml b/.travis.yml
new file mode 100644
index 0000000..9c9035b
--- /dev/null
+++ b/.travis.yml
@@ -0,0 +1,33 @@
+#
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+#
+language: java
+sudo: false
+jdk:
+- openjdk8
+install: true
+script: "./travis.sh"
+env:
+  global:
+    - BUILD_SNAPSHOTS_BRANCH=develop
+    - ARTIFACTORY_URL=https://mifos.jfrog.io/mifos
+    - ARTIFACTORY_USER=travis-ci
+    - secure: "ccFs6pGBQDhjbc2Dj79fjH2qemX3f3OUITFpVPTiJjacl8kN/lsUG/popLLsjqLXQo0LYPbo+pDT5lb4DUIyZ9hyTqyKgv3gPnbiiQLiUPa7f73/+978mtC9x6Cgkxxd1v25FPMO1y4jnhSB+NfGdVhAz7Ymp+W1AcKs6pNv5pblP2JCmwQF+brtkqtuwa8qKoMxLenl0a91+x8pb2jfGX5Ti+7R5NJA9ofRifJHv5NraLS2hjdY5DYEBFCTPxrGS/YFhpceyeH4quNYNPwzLjmNKQhhPldQYZBpHZc5SzTBxdHyb6f4ojRXE0cVg0hX8O4N2M9jpXgh0d/TJ3ljbUAAZ7gmUj2B6wNhvK6pjp+ErMX10RHOMbwCRZASqc/5sK/IosIYCk55H8TKtWmJ7BEhQ/FAcdxcpOZcJsnqy2QLVAnOvemrVr1CjyAyVFg6oMpvrWTru54zmVgWR5VOmlZyRPbpyvwvkk+2DhKmiS+Gho0PEc+noWk7D3eV6mrIg/FePZjJszlmWOfjLBKw7MtdCyKaG+cYGzniG7ILkcMP/eXoTuA5ZnSJcTFtjt/+cliyDXZADaNNeQLif+Qu+4XTdkiRbnR3t7uNvibt8N627W4EXWC5aT2HuHUhoGFfQGl1jtUY0M7dd+CBsLf8gnYIAspPpkbJOnWP9ro1eeo="
+after_failure:
+  - ./gradlew rat
+  - cat build/reports/rat/rat-report.txt
diff --git a/README.md b/README.md
index 797cd82..1df5cae 100644
--- a/README.md
+++ b/README.md
@@ -1,4 +1,4 @@
-# Apache Fineract CN default setup
+# Apache Fineract CN default setup [![Build Status](https://api.travis-ci.com/apache/fineract-cn-default-setup.svg?branch=develop)](https://travis-ci.com/apache/fineract-cn-default-setup)
 
 This project provides resources which can be used to create a default setup for microservices in [Apache Fineract CN](https://github.com/search?q=org%3Aapache+fineract) deployment. It is dependent on the apis and importers of those microservices.
 
diff --git a/accounting/build.gradle b/accounting/build.gradle
index 750b592..35c385d 100644
--- a/accounting/build.gradle
+++ b/accounting/build.gradle
@@ -32,6 +32,7 @@
 plugins {
     id "com.github.hierynomus.license" version "0.13.1"
     id("org.nosphere.apache.rat") version "0.3.1"
+    id "com.jfrog.artifactory" version "4.9.5"
 }
 
 apply from: '../shared.gradle'
@@ -49,7 +50,7 @@
             from components.java
             groupId project.group
             artifactId project.name
-            version project.version
+            version project.findProperty('externalVersion') ?: project.version
         }
     }
 }
diff --git a/build.gradle b/build.gradle
index 181d7d7..7c138e7 100644
--- a/build.gradle
+++ b/build.gradle
@@ -26,6 +26,12 @@
     dependsOn publishAccountingToMavenLocal
 }
 
+task artifactoryPublish {
+    group 'all'
+    dependsOn publishToMavenLocal
+    dependsOn gradle.includedBuild('accounting').task(':artifactoryPublish')
+}
+
 task licenseFormat {
     group 'all'
     dependsOn gradle.includedBuild('accounting').task(':licenseFormat')
@@ -34,4 +40,4 @@
 task rat {
     group 'all'
     dependsOn gradle.includedBuild('accounting').task(':rat')
-}
\ No newline at end of file
+}
diff --git a/shared.gradle b/shared.gradle
index 7a56e4c..d6c79b9 100644
--- a/shared.gradle
+++ b/shared.gradle
@@ -36,6 +36,7 @@
 repositories {
     jcenter()
     mavenLocal()
+    maven { url 'https://mifos.jfrog.io/mifos/libs-snapshot/' }
 }
 
 dependencyManagement {
@@ -61,6 +62,22 @@
     duplicatesStrategy = DuplicatesStrategy.EXCLUDE
 }
 
+artifactory {
+    contextUrl = System.getenv("ARTIFACTORY_URL")
+    publish {
+        repository {
+            repoKey = project.findProperty('artifactoryRepoKey')
+            username = System.getenv("ARTIFACTORY_USER")
+            password = System.getenv("ARTIFACTORY_PASSWORD")
+        }
+
+        defaults {
+            publications ('service')
+        }
+    }
+}
+artifactoryPublish.dependsOn('clean','publishToMavenLocal')
+
 license {
     header rootProject.file('../HEADER')
     strictCheck true
@@ -84,4 +101,5 @@
             "gradlew.bat",
             "README.md"
     ]
+    plainOutput = true
 }
diff --git a/travis.sh b/travis.sh
new file mode 100755
index 0000000..03a75ee
--- /dev/null
+++ b/travis.sh
@@ -0,0 +1,71 @@
+#!/usr/bin/env bash
+#
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+#
+
+# Documentation: https://cwiki.apache.org/confluence/display/FINERACT/Fineract-CN+Artifactory
+
+#Exit immediately if a command exits with a non-zero status.
+set -e
+EXIT_STATUS=0
+
+# Builds and Publishes a SNAPSHOT
+function build_snapshot() {
+  echo -e "Building and publishing a snapshot out of branch [$TRAVIS_BRANCH]"
+  ./gradlew -PartifactoryRepoKey=libs-snapshot-local -DbuildInfo.build.number=${TRAVIS_COMMIT::7} artifactoryPublish --stacktrace || EXIT_STATUS=$?
+}
+
+# Builds a Pull Request
+function build_pullrequest() {
+  echo -e "Building pull request #$TRAVIS_PULL_REQUEST of branch [$TRAVIS_BRANCH]. Won't publish anything to Artifactory."
+  ./gradlew publishToMavenLocal rat || EXIT_STATUS=$?
+}
+
+# For other branches we need to add branch name as prefix
+function build_otherbranch() {
+  echo -e "Building a snapshot out of branch [$TRAVIS_BRANCH] and publishing it with prefix '${TRAVIS_BRANCH}-SNAPSHOT'"
+  ./gradlew -PartifactoryRepoKey=libs-snapshot-local -DbuildInfo.build.number=${TRAVIS_COMMIT::7} -PexternalVersion=${TRAVIS_BRANCH}-SNAPSHOT artifactoryPublish --stacktrace || EXIT_STATUS=$?
+}
+
+# Builds and Publishes a Tag
+function build_tag() {
+  echo -e "Building tag [$TRAVIS_TAG] and publishing it as a release"
+  ./gradlew -PartifactoryRepoKey=libs-release-local -PexternalVersion=$TRAVIS_TAG artifactoryPublish --stacktrace || EXIT_STATUS=$?
+
+}
+
+echo -e "TRAVIS_BRANCH=$TRAVIS_BRANCH"
+echo -e "TRAVIS_TAG=$TRAVIS_TAG"
+echo -e "TRAVIS_COMMIT=${TRAVIS_COMMIT::7}"
+echo -e "TRAVIS_PULL_REQUEST=$TRAVIS_PULL_REQUEST"
+
+# Build Logic
+if [ "$TRAVIS_PULL_REQUEST" != "false" ]; then
+  build_pullrequest
+elif [ "$TRAVIS_PULL_REQUEST" == "false" ] && [ "$TRAVIS_BRANCH" != "$BUILD_SNAPSHOTS_BRANCH" ] && [ "$TRAVIS_TAG" == "" ]  ; then
+  build_otherbranch
+elif [ "$TRAVIS_PULL_REQUEST" == "false" ] && [ "$TRAVIS_BRANCH" == "$BUILD_SNAPSHOTS_BRANCH" ] && [ "$TRAVIS_TAG" == "" ] ; then
+  build_snapshot
+elif [ "$TRAVIS_PULL_REQUEST" == "false" ] && [ "$TRAVIS_TAG" != "" ]; then
+  build_tag
+else
+  echo -e "WARN: Unexpected env variable values => Branch [$TRAVIS_BRANCH], Tag [$TRAVIS_TAG], Pull Request [#$TRAVIS_PULL_REQUEST]"
+  ./gradlew clean build
+fi
+
+exit ${EXIT_STATUS}